dnl -*- shell-script -*-
dnl
dnl Copyright (c) 2001-2003 The Trustees of Indiana University.  
dnl                         All rights reserved.
dnl Copyright (c) 1998-2001 University of Notre Dame. 
dnl                         All rights reserved.
dnl Copyright (c) 1994-1998 The Ohio State University.  
dnl                         All rights reserved.
dnl 
dnl This file is part of the XMPI software package.  For license
dnl information, see the LICENSE file in the top level directory of the
dnl XMPI source distribution.
dnl
dnl $Id: mpi_check_mpi_h.m4,v 1.2 2003/08/23 13:36:00 jsquyres Exp $
dnl

define([LSC_MPI_CHECK_MPI_H],[
#
# Arguments: None
#
# Dependencies: None
# 
# Aborts if we cannot #include<mpi.h>
#

AC_MSG_CHECKING([for mpi.h])
# See if we can find <mpi.h>
touch conftest.o conftest.lo
rm -f conftest.o conftest.lo
cat > conftest.$ac_ext <<EOF
#include <mpi.h>
int
main(int argc, char* argv[])
{ return 0; }
EOF
echo configure:__oline__: $ac_compile >&5
(eval $ac_compile) 2>&5
if test -f conftest.o -o -f conftest.lo ; then
    AC_MSG_RESULT([yes])
else
    echo configure:__oline__: here is the program that failed: >&5
    cat conftest.$ac_ext >&5
    AC_MSG_RESULT([no])
    AC_MSG_ERROR([cannot continue -- cannot find <mpi.h>])
fi
# Kill all temporaries
rm -f conftest*
# Be social; clean up all variables used
unset lsc_prefix])dnl

